<template>
  <FormGenerator
    :selected-shape="selectedApplicationProfile.base_url"
    :shapes="completeApplicationProfile.definition.toCanonical()"
    shapes-mime-type="application/n-quads"
    :locale="$i18n.locale"
    :form-data="metadata"
    :disabled-mode="readOnly"
    :class-receiver="classReceiver"
    :instance-receiver="instanceReceiver"
    @update:form-data="setMetadata"
    @isValid="isValid"
  />
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { Dataset } from "@rdfjs/types";

import FormGenerator from "@coscine/form-generator";
import "@coscine/form-generator/dist/style.css";

import type ValidationReport from "rdf-validate-shacl/src/validation-report";

import ApplicationProfileImpl from "@/classes/ApplicationProfileImpl";

import serviceProvider from "@/util/service-providers/service-provider";

import { defineComponent, type PropType } from "vue";

export default defineComponent({
  name: "MetadataForm",
  components: {
    FormGenerator,
  },
  props: {
    completeApplicationProfile: {
      required: true,
      type: Object as PropType<{
        definition: Dataset;
        inheritedParts: Record<
          string,
          {
            applicationProfile: ApplicationProfile;
            definition: Dataset;
          }
        >;
      }>,
    },
    metadata: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    readOnly: {
      default: false,
      type: Boolean,
    },
    selectedApplicationProfile: {
      required: false,
      default: () =>
        new ApplicationProfileImpl("", "", {
          definition: "[]",
          mimeType: "application/ld+json",
        }),
      type: Object as PropType<ApplicationProfile>,
    },
    selectedDefinition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
  },
  data() {
    return {
      classReceiver: serviceProvider.apiConnection.classReceiver,
      instanceReceiver: serviceProvider.apiConnection.instanceReceiver,
    };
  },
  methods: {
    isValid(valid: ValidationReport) {
      this.$emit("isValid", valid);
    },
    setMetadata(metadata: Dataset) {
      this.$emit("setMetadata", metadata);
    },
  },
});
</script>
